import { request } from "./axios";
import { setItem, getItem, removeItem } from "./localStorage";

const storageKeys = {
  TOKEN: "AUTHORIZATION_TOKEN"
};

const authenticate = async (username, password) => {
  const urlTemplate = process.env.REACT_APP_IDENTITY_AUTHENTICATION_URL;
  const url = urlTemplate
    .replace("{username}", username)
    .replace("{password}", password);
  const options = {
    method: "post"
  };

  const response = await request(url, options);
  if (response.status === "SUCCESS") {
    setItem(storageKeys.TOKEN, response.token);
  }

  return response;
};

const invalidate = () => {
  const token = getItem(storageKeys.TOKEN);
  if (token) {
    removeItem(storageKeys.TOKEN);
  }
};

export { storageKeys, authenticate, invalidate };
